unit sBDEControls;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, sControls, sCustomComboBox, dbtables, sConst;

Type

  TsComboBox = class(TsCustomComboBox)
  private
  protected
    { Protected declarations }
    FDatabase : TDatabase;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    function Generate : integer; override;
  published
    { Published declarations }
    property Database:TDatabase read FDatabase write FDatabase;

  end;

  TsBDEComboBox = class(TsCustomComboBox)
  private
  protected
    { Protected declarations }
    FDatabase : TDatabase;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    function Generate : integer; override;
  published
    { Published declarations }
    property Database:TDatabase read FDatabase write FDatabase;
  end;

implementation

constructor TsComboBox.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsComboBox;
end;

function TsComboBox.Generate : integer;
var
  q: TQuery;
  s, t: string;
begin
  Result := 0;
  if Assigned(Database) and (SQL.Text<>'') then begin
    q:=TQuery.Create(Self);
    q.DatabaseName := Database.DatabaseName;
    q.SQL.Assign(SQL);
    q.Open;

    q.first;
    Clear;
    if sStyle.DefaultString<>'' then begin
      Items.Add(sStyle.DefaultString);
    end;
    while not q.eof do begin
      if (CharsInCode > 0) and (q.FieldCount > 1) then begin
       if Length(q.Fields[1].AsString) < CharsInCode then begin
         s:='0';
         while Length(s) < CharsInCode - length(q.Fields[1].AsString) do begin
           s:=s+'0';
         end;
         t := s + q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end
       else begin
         t := q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end;
      end
      else begin
        t := q.Fields[0].AsString;
      end;
      Items.Add(t);
      q.next;
    end;
    q.Free;
    if Items.Count < DropDownCount then begin
      DropDownCount := Items.Count;
    end;
    Result := Items.Count;
    if sStyle.DefaultString <> '' then begin
      ItemIndex := 0;
    end;
  end;
end;

constructor TsBDEComboBox.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsADOComboBox;
end;

function TsBDEComboBox.Generate : integer;
var
  q: TQuery;
  s, t: string;
begin
  Result := 0;
  if Assigned(Database) and (SQL.Text<>'') then begin
    q:=TQuery.Create(Self);
    q.DatabaseName := Database.DatabaseName;
    q.SQL.Assign(SQL);
    q.Open;

    q.first;
    Clear;
    if sStyle.DefaultString<>'' then begin
      Items.Add(sStyle.DefaultString);
    end;
    while not q.eof do begin
      if (CharsInCode > 0) and (q.FieldCount > 1) then begin
       if Length(q.Fields[1].AsString) < CharsInCode then begin
         s:='0';
         while Length(s) < CharsInCode - length(q.Fields[1].AsString) do begin
           s:=s+'0';
         end;
         t := s + q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end
       else begin
         t := q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end;
      end
      else begin
        t := q.Fields[0].AsString;
      end;
      Items.Add(t);
      q.next;
    end;
    q.Free;
    if Items.Count < DropDownCount then begin
      DropDownCount := Items.Count;
    end;
    Result := Items.Count;
    if sStyle.DefaultString <> '' then begin
      ItemIndex := 0;
    end;
  end;
end;

end.
