unit sControls;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, ToolEdit, CurrEdit, ComCtrls, {$IFDEF EXTS} DBGridEH, {$ENDIF}
  ToolWin, ExtCtrls, RXCtrls, sPanel, sConst;

const
  ColCount = 24;

type

  TMouseNotify=procedure (Sender:Tobject) of object;
{$IFDEF EXTS}
  TsCustomSorter = class(TsPanel)
  private
    FDBGrid : TDBGridEH;
    FActive : boolean;
    FDraggedIn : boolean;
    FDraggedOut : boolean;
    FShowCaptions : boolean;
    FDragObject : TDragObject;
    FRadius : integer;
    FButtonSize : integer;
    Btn : TRxSpeedButton;
//    FBtnArray : array [1..ColCount] of TCirclePanel;
    FBtnArray : array [1..ColCount] of TPanel;
    FBtnCount : integer;

    procedure SetActive(Value : boolean);
    procedure SetButtonSize(Value : integer);
  public
    FStartText : string;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure SorterDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SorterDragOver(Sender, Source: TObject; X, Y: Integer;
        State: TDragState; var Accept: Boolean);

    procedure GridStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure GridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure GridDragOver(Sender, Source: TObject; X, Y: Integer;
        State: TDragState; var Accept: Boolean);
    procedure GridTitleBtnClick(Sender: TObject; ACol: Integer;
        Column: TColumnEh);

    procedure BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BtnStartDrag(Sender: TObject; var DragObject: TDragObject);

    procedure ButtonClick(Sender: TObject);
    function GenText : string;

    procedure Execute; virtual; abstract;

    property Canvas;
  published
    property DBGrid: TDBGridEH read FDBGrid write FDBGrid;
    property Active: boolean read FActive write SetActive;
    property Radius: integer read FRadius write FRadius;
    property ButtonSize: integer read FButtonSize write SetButtonSize;
    property ShowCaptions : boolean read FShowCaptions write FShowCaptions;
    property Constraints;
    property OnDockDrop;
    property OnDockOver;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property Align;
    property Autosize;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property Color;
    property Ctl3D;
    property DragCursor;
    property Enabled;
    property FullRepaint;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
  end;
{$ENDIF}
  TsStatusBar = class(TStatusBar)
  private
  protected
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Action;
    property AutoHint;
    property Align default alBottom;
    property Anchors;
    property BiDiMode;
    property BorderWidth;
    property Color default clBtnFace;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property Constraints;
    property Panels;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentFont default False;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property SimplePanel;
    property SimpleText;
    property SizeGrip;
    property UseSystemFont;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnHint;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDrawPanel;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
  end;

implementation

{$IFDEF EXTS}
constructor TsCustomSorter.Create(AOwner: TComponent);
var
  i:integer;
  List : TList;
begin
  inherited Create(AOwner);
  Parent := TWinControl(AOwner);
  FDragObject := TDragObject.Create;

  OnDragDrop := SorterDragDrop;
  OnDragOver := SorterDragOver;
  Align := alNone;
  Hint := '  ,    ,   ';
  Caption := ' ';
  BevelOuter := bvLowered;
//  BevelInner := bvLowered;
  Width := 480;
  BorderWidth := 4;
  Alignment := taLeftJustify;

  //  
  Btn := TRxSpeedButton.Create(Self);
  Btn.Parent := Self;
  Btn.Flat := True;
  Btn.Align := alClient;
  Btn.Caption := '';
  Btn.Transparent := True;
  Btn.OnDragDrop := SorterDragDrop;
  Btn.OnDragOver := SorterDragOver;
  Btn.OnClick := ButtonClick;
  Btn.Hint := Hint;

  ButtonSize := 22;

  AutoSize := True;

  List := TList.Create;
  Parent.GetTabOrderList(List);
  if List.Count>0 then begin
    for i:=0 to List.Count-1 do begin
      if TWinControl(List[i]) is TDBGridEH then begin
        Self.DBGrid := TDBGridEH(TWinControl(List[i]));
      end;
    end;
  end;
  List.Free;
end;

procedure TsCustomSorter.SetButtonSize(Value : integer);
begin
  FButtonSize := Value;
  Btn.Constraints.MaxHeight := Value;
  Btn.Constraints.MinHeight := Value;
  Btn.Constraints.MaxWidth := Value * 4;
  Btn.Constraints.MinWidth := Value * 4;
  Constraints.MaxHeight := Value + BorderWidth * 2 + 2;
  Constraints.MinHeight := Value + BorderWidth * 2 + 2;
end;

destructor TsCustomSorter.Destroy;
begin
  FDragObject.Free;
  inherited Destroy;
end;

function TsCustomSorter.GenText : string;
var
  s : string;
  procedure GetTextFromMin(l : integer);
  var
    i, b : integer;
  begin
    b := -1;
    for i := 1 to ColCount do begin //    (!) ,   L
      //  i-   L,  B=-1,     B
      if ((FBtnArray[i] <> nil) and FBtnArray[i].Visible and (L < FBtnArray[i].Left)) then begin
        if b = -1 then b := i;
        //   
        if ((FBtnArray[i] <> nil) and (FBtnArray[b].Left > FBtnArray[i].Left) and (FBtnArray[i].Left > l)) then begin
          b := i;
        end;
      end;
    end;
    if b <> -1 then begin
      s := iff(s='', s + TColumnEH(FBtnArray[b].Tag).Field.FieldName, s + ', ' + TColumnEH(FBtnArray[b].Tag).Field.FieldName);
      GetTextFromMin(FBtnArray[b].Left);
    end;
  end;
begin
  GetTextFromMin(0);
  Result := s;
end;

procedure TsCustomSorter.ButtonClick(Sender: TObject);
begin
  Execute;
end;

{
procedure TsCustomSorter.Execute;
begin
  ShowWarning('Order by ' + GenText + '?   - .');
end;
}
procedure TsCustomSorter.SetActive(Value : boolean);
begin
  FActive := False;
  if Assigned(DBGrid) then begin
    //  
    DBGrid.OnStartDrag     := GridStartDrag;
    DBGrid.OnDragDrop      := GridDragDrop;
    DBGrid.OnDragOver      := GridDragOver;
    DBGrid.OnTitleBtnClick := GridTitleBtnClick;
    FActive := Value;
  end;
end;

//  
procedure TsCustomSorter.SorterDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  i : integer;
  function FindButton(s : string) : integer;
  var
    i : integer;
  begin
    Result := 0;
    for i := 1 to ColCount do begin
      if FBtnArray[i] <> nil then begin
//        if TCirclePanel(FBtnArray[i]).Name = s then begin
        if TPanel(FBtnArray[i]).Name = s then begin
          Result := i;
          Break;
        end;
      end;
    end;
  end;
begin
  if FDraggedIn then begin
    FDraggedIn := False;
    i := FindButton(TColumnEH(FDragObject.DragTarget).Field.FieldName);
    if i = 0  then begin
      inc(FBtnCount);
//      FBtnArray[FBtnCount] := TCirclePanel.Create(Self);
      FBtnArray[FBtnCount] := TPanel.Create(Self);
      if ShowCaptions then begin
        FBtnArray[FBtnCount].Caption := iff((length(TColumnEH(FDragObject.DragTarget).Field.DisplayLabel) > 20),
                                           copy(TColumnEH(FDragObject.DragTarget).Field.DisplayLabel, 1, 20) + '...',
                                           TColumnEH(FDragObject.DragTarget).Field.DisplayLabel);
      end
      else begin
        FBtnArray[FBtnCount].Caption := IntToStr(TColumnEH(FDragObject.DragTarget).Index + 1);
      end;
      FBtnArray[FBtnCount].Name := TColumnEH(FDragObject.DragTarget).Field.FieldName;
      FBtnArray[FBtnCount].Tag := LongInt(FDragObject.DragTarget);
      FBtnArray[FBtnCount].Parent := Self;
      FBtnArray[FBtnCount].Width := 80;
      FBtnArray[FBtnCount].Font.Color := clBlack;
      FBtnArray[FBtnCount].Font.Style := [];
{
      FBtnArray[FBtnCount].Gradient.Enabled := True;
      FBtnArray[FBtnCount].Gradient.Style := cgsBottom;
      FBtnArray[FBtnCount].Gradient.ColorEnd := clWhite;
      FBtnArray[FBtnCount].Gradient.ColorStart := clBtnShadow;
}
      FBtnArray[FBtnCount].Align := alLeft;

{
      FBtnArray[FBtnCount].Corners.TopLeft.X := Radius;
      FBtnArray[FBtnCount].Corners.TopLeft.Y := Radius;
      FBtnArray[FBtnCount].Corners.BottomLeft.X := Radius;
      FBtnArray[FBtnCount].Corners.BottomLeft.Y := Radius;
      FBtnArray[FBtnCount].Corners.TopRight.X := Radius;
      FBtnArray[FBtnCount].Corners.TopRight.Y := Radius;
      FBtnArray[FBtnCount].Corners.BottomRight.X := Radius;
      FBtnArray[FBtnCount].Corners.BottomRight.Y := Radius;
}
      FBtnArray[FBtnCount].Width := (Length(FBtnArray[FBtnCount].Caption) + 3) * FBtnArray[FBtnCount].Font.Size;

      FBtnArray[FBtnCount].OnMouseDown := BtnMouseDown;
      FBtnArray[FBtnCount].OnStartDrag := BtnStartDrag;
      FBtnArray[FBtnCount].OnDragDrop := SorterDragDrop;
      FBtnArray[FBtnCount].OnDragOver := SorterDragOver;
//      if (Sender is TCirclePanel) or (Sender is TRxSpeedButton) then begin
      if (Sender is TPanel) or (Sender is TRxSpeedButton) then begin
        FBtnArray[FBtnCount].Left := TControl(Sender).Left + 4;
      end
      else begin
        FBtnArray[FBtnCount].Left := X;
      end;
    end
    else begin
//      if (Sender is TCirclePanel) or (Sender is TRxSpeedButton) then begin
      if (Sender is TPanel) or (Sender is TRxSpeedButton) then begin
        FBtnArray[FBtnCount].Left := TControl(Sender).Left + 4;
      end
      else begin
        FBtnArray[FBtnCount].Left := X;
      end;
      FBtnArray[i].Visible := True;
    end;
  end
//  else if (TObject(FDragObject.DragTarget) is TCirclePanel) then begin
  else if (TObject(FDragObject.DragTarget) is TPanel) then begin
//    if (Sender is TCirclePanel) or (Sender is TRxSpeedButton) then begin
    if (Sender is TPanel) or (Sender is TRxSpeedButton) then begin
//      TCirclePanel(FDragObject.DragTarget).Left :=  TControl(Sender).Left + 4;
      TPanel(FDragObject.DragTarget).Left :=  TControl(Sender).Left + 4;
    end
    else begin
//      TCirclePanel(FDragObject.DragTarget).Left := X;
      TPanel(FDragObject.DragTarget).Left := X;
    end;
  end;
  inherited;
end;

//    ?
procedure TsCustomSorter.SorterDragOver(Sender, Source: TObject; X, Y: Integer;
        State: TDragState; var Accept: Boolean);
begin
//  Accept := (TObject(FDragObject.DragTarget) is TCirclePanel) or FDraggedIn;
  Accept := (TObject(FDragObject.DragTarget) is TPanel) or FDraggedIn;
  inherited;
end;

//   
procedure TsCustomSorter.GridTitleBtnClick(Sender: TObject; ACol: Integer; Column: TColumnEh);
begin
  FDragObject.DragTarget := Column;
  DBGrid.BeginDrag(False);
  inherited;
end;

//    
procedure TsCustomSorter.GridStartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  FDraggedIn := True;
  inherited;
end;

//  
procedure TsCustomSorter.GridDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Assigned(FDragObject.DragTarget) then begin
//    TCirclePanel(FDragObject.DragTarget).Visible := False;
    TPanel(FDragObject.DragTarget).Visible := False;
    FDraggedOut := False;
  end;
  inherited;
end;

//    
procedure TsCustomSorter.GridDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
//  Accept := FDraggedOut and (TObject(FDragObject.DragTarget) is TCirclePanel);
  Accept := FDraggedOut and (TObject(FDragObject.DragTarget) is TPanel);
  inherited;
end;

//   
procedure TsCustomSorter.BtnStartDrag(Sender: TObject; var DragObject: TDragObject);
begin
//  FDragObject.DragTarget := TCirclePanel(Sender);
  FDragObject.DragTarget := TPanel(Sender);
  FDraggedOut := True;
  inherited;
end;

//      
procedure TsCustomSorter.BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  TCirclePanel(Sender).BeginDrag(False);
  TPanel(Sender).BeginDrag(False);
  inherited;
end;
{$ENDIF}

{>>>>>>>>>>>>>>>>>>>>>>>>>>> TsSorter >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}

constructor TsStatusBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
//  sStyle.COC := COC_TsStatusBar;
  ControlStyle := [csCaptureMouse, csClickEvents, csDoubleClicks, csOpaque,
                   csAcceptsControls];
end;

end.
