unit sFilenameEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, sStyleUtil, sConst;

type
  TsFilenameEdit = class(TFilenameEdit)
  private
    { Private declarations }
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
  protected
    { Protected declarations }
    FsStyle : TsStyle;
    procedure WndProc (var Message: TMessage); override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    property Button;
    property BorderStyle;
  published
    { Published declarations }
    property sStyle:TsStyle read FsStyle write FsStyle;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('sStyle', [TsFilenameEdit]);
end;

{ TsFilenameEdit }

constructor TsFilenameEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyle.Create(Self);
  sStyle.COC := COC_TsFilenameEdit;
  OnKeyDown := sStyle.OnKeyDown;
  Button.GrayedInactive := True;
//  Button.Glyph.Mask(clFuchsia);
//  Button.NumGlyphs := 2;
//  Button.Glyph.LoadFromResourceName(hInstance, 'BTN_ELLIPSIS');
end;

procedure TsFilenameEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    Color := sStyle.GetActiveColor;
    Button.Flat := sStyle.Flat;
    Button.Transparent := sStyle.Flat;
    if sStyle.Flat then begin
      Button.Left := -3;
      Button.Top := -3;
      BorderStyle := bsNone;
      if Assigned(Parent) then sStyle.RedrawBorder;
    end
    else begin
      Button.Left := 0;
      Button.Top := 0;
      BorderStyle := bsSingle;
    end;
    inherited;
  end;
end;

procedure TsFilenameEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then begin
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
  end;
end;

procedure TsFilenameEdit.WMNCPaint(var Message: TMessage);
begin
  inherited;
  sStyle.RedrawBorder;
end;

procedure TsFilenameEdit.WndProc(var Message: TMessage);
begin
   sStyle.WndProc(Message);
   inherited;
end;

end.
