unit sIBFilterForm;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, ExtCtrls, ComCtrls, ToolWin, StdCtrls, IBTable,
  sIBControls, Db, IBCustomDataSet, IBQuery, sSharedIB, sControls,
  sCustomComboBox, Placemnt, sStyleUtil, sPanel, jpeg, sUtils,
  sCustomButton;

type
  Col=record
      _num:integer;
      _name:string;
      _label:string;
  end;

  Box=record
      _Box1: TsIBComboBox;
      _Box2: TsIBComboBox;
      _Box3: TsIBComboBox;
  end;

  TsIBFilterForm = class(TForm)
    Query1: TIBQuery;
    ActionList1: TActionList;
    ActionAddNew: TAction;
    ActionClearFilter: TAction;
    ActionDelLast: TAction;
    Panel1: TsPanel;
    sPanel1: TsPanel;
    sStyleControl1: TsStyleControl;
    sSpeedButton1: TsSpeedButton;
    sSpeedButton3: TsSpeedButton;
    sPanel2: TsPanel;
    sSpeedButton2: TsSpeedButton;
    sSpeedButton4: TsSpeedButton;
    sSpeedButton5: TsSpeedButton;
    Panel2: TsPanel;
    procedure FormShow(Sender: TObject);
    procedure ActionAddNewExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ActionClearFilterExecute(Sender: TObject);
    procedure ActionOkExecute(Sender: TObject);
    procedure ActionDelLastExecute(Sender: TObject);
    procedure ActionCancelExecute(Sender: TObject);  
  private
    { Private declarations }
  public
    Cols: array [0..127] of Col;
    Boxes: array [0..11] of Box;
    BoxCount : integer;
    num,j: integer;
    sWhere: string;

    TableName : string;
    SelectText : string;
    WhereText : string;
    OrderStr : string;
    DS : TIBQuery;
    procedure CreateBoxes;
    procedure BoxOnChange(Sender : TObject);
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TsIBFilterForm.BoxOnChange(Sender : TObject);
var
  FieldName: string;
begin
  if not TsCustomComboBox(Sender).DroppedDown and (TsCustomComboBox(Sender).ItemIndex <> -1) then begin
    num := TsCustomComboBox(Sender).ItemIndex;
    FieldName := Cols[num + 1]._name;
    //   
    case DS.FieldByName(FieldName).FieldKind of
      fkData : begin
        TsCustomComboBox(TsCustomComboBox(Sender).Tag).SQL.Text := 'SELECT DISTINCT ' + FieldName + ' FROM ' + TableName + ';';
        TsCustomComboBox(TsCustomComboBox(Sender).Tag).Active := True;
        TsCustomComboBox(TsCustomComboBox(TsCustomComboBox(Sender).Tag).Tag).Enabled := True;
        TsCustomComboBox(TsCustomComboBox(Sender).Tag).Style := csDropDown;
      end;
      fkLookup : begin
        TsCustomComboBox(TsCustomComboBox(Sender).Tag).Clear;
        DS.FieldByName(FieldName).LookupDataSet.First;
        while not DS.FieldByName(FieldName).LookupDataSet.EOF do begin
          TsCustomComboBox(TsCustomComboBox(Sender).Tag).Items.Add(DS.FieldByName(FieldName).LookupDataSet.FieldByName(DS.FieldByName(FieldName).LookupResultField).asString);
          DS.FieldByName(FieldName).LookupDataSet.Next;
        end;
        TsCustomComboBox(TsCustomComboBox(TsCustomComboBox(Sender).Tag).Tag).ItemIndex := 0;
        TsCustomComboBox(TsCustomComboBox(TsCustomComboBox(Sender).Tag).Tag).Enabled := False;
        TsCustomComboBox(TsCustomComboBox(Sender).Tag).Style := csDropDownList;
      end;
    end;
  end;
end;

procedure TsIBFilterForm.CreateBoxes;
var
   i,j:integer;
begin
  if BoxCount<12 then begin
    Boxes[BoxCount]._Box1 := TsIBComboBox.Create(Self);
    Boxes[BoxCount]._Box2 := TsIBComboBox.Create(Self);
    Boxes[BoxCount]._Box3 := TsIBComboBox.Create(Self);

    Boxes[BoxCount]._Box1.sStyle.Shadow.DontUse := True;
    Boxes[BoxCount]._Box2.sStyle.Shadow.DontUse := True;
    Boxes[BoxCount]._Box3.sStyle.Shadow.DontUse := True;

    Boxes[BoxCount]._Box1.Top  := 32 + BoxCount * 28;
    Boxes[BoxCount]._Box2.Top  := 32 + BoxCount * 28;
    Boxes[BoxCount]._Box3.Top  := 32 + BoxCount * 28;

    Boxes[BoxCount]._Box1.Left := 20;
    Boxes[BoxCount]._Box2.Left := 203;
    Boxes[BoxCount]._Box3.Left := 250;

    Boxes[BoxCount]._Box1.Width := 182;
    Boxes[BoxCount]._Box2.Width := 46;
    Boxes[BoxCount]._Box3.Width := 182;

    Boxes[BoxCount]._Box1.Parent := Panel1;
    Boxes[BoxCount]._Box2.Parent := Panel1;
    Boxes[BoxCount]._Box3.Parent := Panel1;
    Boxes[BoxCount]._Box3.DropDownCount := 16;
    Boxes[BoxCount]._Box1.Style := csDropDownList;
    Boxes[BoxCount]._Box2.Style := csDropDownList;


    Boxes[BoxCount]._Box3.Database := DS.Database;
    Boxes[BoxCount]._Box1.Clear;
    j:=1;
    for i:=0 to DS.FieldCount-1 do begin
      if (DS.Fields[i].Tag=1) then begin
        cols[j]._num:=i;
        cols[j]._name:=DS.Fields[i].FieldName;
        cols[j]._label:=DS.Fields[i].DisplayLabel;
        Boxes[BoxCount]._Box1.Items.Add(DS.Fields[i].DisplayLabel);
        inc(j);
      end;
    end;
    Boxes[BoxCount]._Box2.Items.Text := '=' + #13+#10 + '<' + #13+#10 + '>' + #13+#10 +
                                        '<=' + #13+#10 + '>=' + #13+#10 + '<>' + #13+#10 +
                                        '';
    Boxes[BoxCount]._Box1.Tag := integer(Boxes[BoxCount]._Box3);
    Boxes[BoxCount]._Box3.Tag := integer(Boxes[BoxCount]._Box2);
    Boxes[BoxCount]._Box1.OnChange := BoxOnChange;
    inc(BoxCount);
    Height :=  95 + BoxCount * 28;
  end;
end;

procedure TsIBFilterForm.FormShow(Sender: TObject);
var
  s: string;
begin
  inherited;
  if BoxCount = 0 then begin
    CreateBoxes;
  end;
  if WhereText = ''
    then s := sWhere
    else s := WhereText + ' and ' + sWhere;
  SelectIBQuery(Query1, 'select count(*) from ' + TableName + iff(sWhere <> '', ' where ' + s, ''));
  Panel2.Caption := Query1.Fields[0].asString;
end;

procedure TsIBFilterForm.ActionAddNewExecute(Sender: TObject);
begin
  inherited;
  CreateBoxes;
end;

procedure TsIBFilterForm.FormDestroy(Sender: TObject);
begin
  while BoxCount > 0 do begin
    Boxes[BoxCount-1]._Box1.Free;
    Boxes[BoxCount-1]._Box2.Free;
    Boxes[BoxCount-1]._Box3.Free;
    dec(BoxCount);
  end;
  inherited;
end;

procedure TsIBFilterForm.ActionClearFilterExecute(Sender: TObject);
begin
  inherited;
  SelectIBQuery(DS, iff(SelectText='', 'select * from ' + TableName, SelectText));
  SelectIBQuery(Query1, 'select count(*) from ' + TableName + iff(WhereText <> '', ' where ' + WhereText, ''));
  Panel2.Caption := Query1.Fields[0].asString;
  sWhere := '';
  ActionClearFilter.Enabled := False;
  Close;
end;

procedure TsIBFilterForm.ActionOkExecute(Sender: TObject);
var
  s: string;
  i: integer;
  //  -   
  function BoxCorrected(j : integer) : boolean;
  begin
      Result := (Boxes[j]._Box1.Text <> '') and (Boxes[j]._Box2.Text <> '');
  end;
  //   Where
  function GetFraze(j : integer) : string;
  var
    FieldName : string;
  begin
    FieldName := Cols[Boxes[i]._Box1.ItemIndex + 1]._name;
    case DS.FieldByName(FieldName).FieldKind of
      fkData : begin
        Result := FieldName + ' ' +
                  iff(Boxes[i]._Box2.ItemIndex <> 6,
                     Boxes[i]._Box2.Text + '''' + Boxes[i]._Box3.Text + '''',
                     ' like ' + '''%' + Boxes[i]._Box3.Text + '%''');
      end;
      fkLookup : begin
        SelectIBQuery(Query1, 'select ' + DS.FieldByName(FieldName).LookupKeyFields +
                              ' from ' + TIBTable(DS.FieldByName(FieldName).LookupDataSet).TableName +
                              ' where ' + DS.FieldByName(FieldName).LookupResultField + '=''' + Boxes[i]._Box3.Text + '''');
        Result := DS.FieldByName(FieldName).KeyFields + '=' +
                     Query1.Fields[0].asString;
      end;
    end;
  end;
begin
  if BoxCount > 0 then begin
    i := 0;
    sWhere := '';
    if BoxCorrected(i) then begin
      sWhere := sWhere + GetFraze(i)
    end
    else begin
      ShowWarning('    ' + IntToStr(i+1) + '!');
    end;
    inc(i);
    while i < BoxCount do begin
      if BoxCorrected(i) then begin
        sWhere := sWhere + ' and ' + GetFraze(i);
      end
      else begin
        ShowWarning('    ' + IntToStr(i+1) + '!');
      end;
      inc(i);
    end;

  if WhereText = ''
    then s := sWhere
    else s := WhereText + ' and ' + sWhere;
    if s <> '' then begin
      SelectIBQuery(DS, 'SELECT * FROM ' + TableName + ' WHERE ' + s + ' ' + OrderStr + ';');
      SelectIBQuery(Query1, 'select count(*) from ' + TableName + iff(s <> '', ' where ' + s, ''));
      Panel2.Caption := Query1.Fields[0].asString;
      ActionClearFilter.Enabled := True;
    end;
  end;
end;

procedure TsIBFilterForm.ActionDelLastExecute(Sender: TObject);
begin
  if BoxCount > 0 then begin
    Boxes[BoxCount-1]._Box1.Free;
    Boxes[BoxCount-1]._Box2.Free;
    Boxes[BoxCount-1]._Box3.Free;
    dec(BoxCount);
    Height :=  98 + BoxCount * 28;
  end;
end;

procedure TsIBFilterForm.ActionCancelExecute(Sender: TObject);
begin
  Close;
end;

end.
