unit sStoreUtils;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, ExtCtrls, ActnList, StdCtrls, Placemnt, jpeg, sStyleUtil,
  sConst, RxGrdCpt, Menus, sPanel, dbgrids, inifiles, registry, sUtils,
  sEdit, sIBControls, sMemo, sCurrencyEdit, sControls, sCustomComboBox,
  sBDEControls, sDateEdit, sCheckBox, sComboEdit, sCheckedControl,
  sDBComboBox, sRadioButton, sPageControl, sGraphUtils, db, buttons;

//<<<<<<<<<<<<<<<<<<<<< Work with Windows system registry and ini <<<<<<<<<<<<<<
{    }
function ReadRegString(Key:integer; Section, Named:string):string;
{    }
procedure WriteRegString(Section, Named, Value:string);
function ReadIniInt(FileName, Section, Named:string): integer;
{    INI-}
function ReadIniString(FileName, Section, Named:string):string;
function ReadIniInteger(Section, Named, FileName: string): integer; overload;
function ReadIniInteger(Section, Named: string; r: TIniFile): integer; overload;
{    INI-}
procedure WriteIniString(FileName, Section, Named, Value:string);
{    DBGridEHa.    Form.onShow.}
procedure SaveOurGrid(Grid:TCustomDBGrid; IniFileName: string);
{    DBGridEHa.    Form.onShow.}
procedure RestoreOurGrid(Grid:TCustomDBGrid; IniFileName: string);
{   .   .
    Form.onShow  onCreate.}
procedure RestoreCaptions(Form: TForm; IniFileName: string);
{   .   .
    Form.onShow  onCreate.}
procedure SaveCaptions(Form: TForm; IniFileName: string);
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

implementation

function ReadIniString(FileName, Section, Named:string):string;
var
  r:TIniFile;
  s:string;
begin
  s:='';
  r:=TIniFile.Create(FileName);
  s:=r.ReadString(Section,Named,'');
  r.Free;
  Result:=s;
end;

function ReadIniInteger(Section, Named, FileName: string): integer;
var
  r: TIniFile;
  s: string;
begin
  r := TIniFile.Create(FileName);
  s := r.ReadString(Section,Named, '');
  r.Free;
  try
    Result := iffi(s='', 0, StrToInt(s));;
  except
  end;
end;

function ReadIniInteger(Section, Named: string; r: TIniFile): integer; overload;
var
  s: string;
begin
  if Assigned(r) then begin
    s := r.ReadString(Section,Named, '');
    if s = '' then s := '0'; 
    try
      Result := StrToInt(s);
    except
    end;
  end;
end;

function ReadIniInt(FileName, Section, Named:string): integer;
var
  r:TIniFile;
  s:string;
begin
  s:='';
  r:=TIniFile.Create(FileName);
  s:=r.ReadString(Section,Named,'');
  r.Free;
  if s = '' then s := '0';
  Result:=StrToInt(s);
end;

function ReadRegString(Key:integer; Section, Named:string):string;
var
  r:TRegIniFile;
begin
  Result:='';
  r:=TRegIniFile.Create('');
  r.RootKey:=Key;
  Result:=r.ReadString(Section,Named,'');
  r.Free;
end;

procedure WriteRegString(Section, Named, Value:string);
var
  r:TRegIniFile;
begin
  r:=TRegIniFile.Create('');
  r.RootKey:=HKEY_CURRENT_USER;
  r.WriteString(Section, Named, Value);
  r.Free;
end;

procedure WriteIniString(FileName, Section, Named,Value:string);
var
  r:TIniFile;
begin
  r:=TIniFile.Create(FileName);
  if r<>nil then r.WriteString(Section,Named,Value);
  r.Free;
end;

procedure SaveOurGrid(Grid:TCustomDBGrid; IniFileName: string);
var
  i : integer;
  f: TCustomForm;
begin
  f := GetParentForm(Grid);
  for i := 0 to Grid.FieldCount - 1 do begin
//    WriteIniString(IniFileName, 'T' + f.Name + Grid.Name, 'Item' + IntToStr(i), IntToStr(Grid.Columns[i].Width));
  end;
end;

procedure RestoreOurGrid(Grid:TCustomDBGrid; IniFileName: string);
var
  i : integer;
  s : string;
  f: TCustomForm;
begin
  f := GetParentForm(Grid);
  for i := 0 to Grid.FieldCount - 1 do begin
    s := ReadIniString(IniFileName, 'T' + f.Name + Grid.Name, 'Item' + IntToStr(i));
    if s <> '' then begin
      try
//        Grid.Columns[i].Width := StrToInt(s);
      except
      end;
    end;
  end;
end;

procedure RestoreCaptions(Form: TForm; IniFileName: string);
var
  i : integer;
  s : string;
  m : TMessage;
begin
  s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Name + '_Caption');
  Form.Caption := iff(s<>'', s, Form.Caption);

  for i := 0 to Form.ComponentCount-1 do begin
    s := UpperCase(Form.Components[i].ClassName);
    if Form.Components[i] is TLabel then begin // TLabel
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      TLabel(Form.Components[i]).Caption := iff(s<>'', s, TLabel(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TAction then begin // TAction
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      if s<>'' then TAction(Form.Components[i]).Caption := s;
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint');
      TAction(Form.Components[i]).Hint := iff(s<>'', s, TAction(Form.Components[i]).Hint);
    end else
    if Form.Components[i] is TsCheckedControl then begin // TCheckBox
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      TsCheckedControl(Form.Components[i]).Caption := iff(s<>'', s, TsCheckedControl(Form.Components[i]).Caption);
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint');
      TsCheckedControl(Form.Components[i]).Hint := iff(s<>'', s, TsCheckedControl(Form.Components[i]).Hint);
    end else
    if Form.Components[i] is TMenuItem then begin // TMenuItem
      if not Assigned(TMenuItem(Form.Components[i]).Action) then begin
        s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
        TMenuItem(Form.Components[i]).Caption := iff(s<>'', s, TMenuItem(Form.Components[i]).Caption);
        s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint');
        TMenuItem(Form.Components[i]).Hint := iff(s<>'', s, TMenuItem(Form.Components[i]).Hint);
      end;
    end else
    if Form.Components[i] is TField then begin // TField
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_DisplayLabel');
      TField(Form.Components[i]).DisplayLabel := iff(s<>'', s, TField(Form.Components[i]).DisplayLabel);
    end else
    if Form.Components[i] is TToolButton  then begin //TToolButton
      if not Assigned(TToolButton(Form.Components[i]).Action) then begin
        s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
        TToolButton(Form.Components[i]).Caption := iff(s<>'', s, TToolButton(Form.Components[i]).Caption);
        s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint');
        TToolButton(Form.Components[i]).Caption := iff(s<>'', s, TToolButton(Form.Components[i]).Hint);
      end;
    end else
    if Form.Components[i] is TRxGradientCaption then begin // TRxGradientCaption
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_FormCaption');
      TRxGradientCaption(Form.Components[i]).FormCaption := iff(s<>'', s, TRxGradientCaption(Form.Components[i]).FormCaption);
    end else
    if Form.Components[i] is TTabSheet then begin // TTabSheet
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      TTabSheet(Form.Components[i]).Caption := iff(s<>'', s, TTabSheet(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TSpeedButton then begin // TSpeedButton
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      TSpeedButton(Form.Components[i]).Caption := iff(s<>'', s, TSpeedButton(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TsCheckedControl then begin // TsCheckedControl
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption');
      TsCheckedControl(Form.Components[i]).Caption := iff(s<>'', s, TsCheckedControl(Form.Components[i]).Caption);
    end;


    try
    if (GetStyleInfo(Form.Components[i]) > 2) and (TsCustomStyle(GetsStyle(TWinControl(Form.Components[i]))).Caption.Text <> '') then begin // TsStyle.Caption
      s := ReadIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_sCaption');
      TsCustomStyle(GetsStyle(TWinControl(Form.Components[i]))).Caption.Text := iff(s<>'', s, TsCustomStyle(GetsStyle(TWinControl(Form.Components[i]))).Caption.Text);
    end;
    except
      ShowMessage(Form.Components[i].Name);
    end;
  end;
end;

procedure SaveCaptions(Form: TForm; IniFileName: string);
var
  i : integer;
//  s : string;
begin
  WriteIniString(IniFileName, 'T' + Form.Name, Form.Name + '_Caption', Form.Caption);
  for i := 0 to Form.ComponentCount-1 do begin
//    s := UpperCase(Form.Components[i].ClassName);
    if Form.Components[i] is TLabel then begin // TLabel
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TLabel(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TAction then begin // TAction
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TAction(Form.Components[i]).Caption);
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint', TAction(Form.Components[i]).Hint);
    end else
    if Form.Components[i] is TsCheckedControl then begin // TCheckBox
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TsCheckedControl(Form.Components[i]).Caption);
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint', TsCheckedControl(Form.Components[i]).Hint);
    end else
    if Form.Components[i] is TMenuItem then begin // TMenuItem
      if not Assigned(TMenuItem(Form.Components[i]).Action) then begin
        WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TMenuItem(Form.Components[i]).Caption);
        WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint', TMenuItem(Form.Components[i]).Hint);
      end;
    end else
    if Form.Components[i] is TField then begin // TField
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_DisplayLabel', TField(Form.Components[i]).DisplayLabel);
    end else
    if Form.Components[i] is TToolButton  then begin //TToolButton
      if not Assigned(TToolButton(Form.Components[i]).Action) then begin
        WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TToolButton(Form.Components[i]).Caption);
        WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Hint', TToolButton(Form.Components[i]).Hint);
      end;
    end else
    if Form.Components[i] is TRxGradientCaption then begin // TRxGradientCaption
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_FormCaption', TRxGradientCaption(Form.Components[i]).FormCaption);
    end else
    if Form.Components[i] is TTabSheet then begin // TTabSheet
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TTabSheet(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TSpeedButton then begin // TSpeedButton
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TSpeedButton(Form.Components[i]).Caption);
    end else
    if Form.Components[i] is TsCheckedControl then begin // TsCheckedControl
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_Caption', TsCheckedControl(Form.Components[i]).Caption);
    end;
    if (GetStyleInfo(Form.Components[i]) > 2) and (TsCustomStyle(GetsStyle(TWinControl(Form.Components[i]))).Caption.Text <> '') then begin // TsStyle.Caption
      WriteIniString(IniFileName, 'T' + Form.Name, Form.Components[i].Name + '_sCaption', TsCustomStyle(GetsStyle(TWinControl(Form.Components[i]))).Caption.Text);
    end;
  end;
end;

end.
