unit sVclUtils;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Classes, Controls, db, StrUtils, SysUtils, StdCtrls, sSharedIB, Dialogs,
  Graphics, Forms, Messages, windows, dbCtrls, extctrls,
  comctrls, ToolEdit,  sConst, RxGrdCpt, Menus, sPanel, dbgrids, inifiles, registry, sUtils,
  sEdit, sIBControls, sMemo, sCurrencyEdit, sControls, sCustomComboBox,
  sBDEControls, sDateEdit, sCheckBox, sComboEdit, sCheckedControl,
  sDBComboBox, sRadioButton, sPageControl, sGraphUtils, buttons;

procedure ChangeControlPattern(s: string);
{   }
function GetParentForm(Control: TComponent) : TCustomForm;
{        }
procedure SetPanelFocus(Panel : TWinControl);
{   Controls  Panel}
procedure ClearPanel(Panel : TWinControl);
procedure SetControlsEnabled(Parent:TWinControl; Value: boolean);
{ :   Controls  }
function CheckPanelFilled(Panel:TCustomPanel):boolean;
{ }
procedure Delay(MSecs: Integer);
{   }
//procedure PanelOnEnter(Sender: TObject);
{   }
//procedure PanelOnExit(Sender: TObject);
{  ComboBoxa}
procedure ComboBoxFilling(ComboBox:TComboBox; DataSet:TDataSet;
       CodeField, NameField:string; CountSymb:integer; FromDOSToWIN: boolean);

implementation


procedure ChangeControlPattern(s: string);
var
  i, j, c, n : integer;
begin
    for i := 0 to Application.ComponentCount-1 do begin
      if Application.Components[i] is TCustomForm then begin
        for j := 0 to TWinControl(Application.Components[i]).ComponentCount-1 do begin
          if TWinControl(Application.Components[i]).Components[j] is TControlBar then begin
            if s <> '' then begin
              TControlBar(TWinControl(Application.Components[i]).Components[j]).Picture.LoadFromFile(s);
              TControlBar(TWinControl(Application.Components[i]).Components[j]).Invalidate;
            end
            else begin
              TControlBar(TWinControl(Application.Components[i]).Components[j]).Picture.Assign(nil);
            end;
          end
        end;
        for j := 0 to TWinControl(Application.Components[i]).ComponentCount-1 do begin
          if TWinControl(Application.Components[i]).Components[j] is TToolBar then begin
              TToolBar(TWinControl(Application.Components[i]).Components[j]).Refresh;
          end
        end;
      end
    end;
end;

function GetParentForm(Control: TComponent) : TCustomForm;
var
  c: TComponent;
begin
  Result := nil;
  c := Control;
  while Assigned(c) and not (c is TCustomForm) do begin
    c := c.Owner;
  end;
  if (c is TCustomForm) then begin
    Result := TCustomForm(c);
  end;
end;

procedure SetPanelFocus(Panel : TWinControl);
var
  List : TList;
  i : integer;
begin
  List := TList.Create;
  Panel.GetTabOrderList(List);
  if List.Count>0 then begin
    for i:=0 to List.Count-1 do begin
      if TWinControl(List[i]).Enabled and TWinControl(List[i]).TabStop then begin
        TWinControl(List[i]).SetFocus;
        Break;
      end;
    end;
  end;
  List.Free;
end;

procedure SetControlsEnabled(Parent:TWinControl; Value: boolean);
var
   i:integer;
begin
  for i:=0 to Parent.ControlCount-1 do begin
    if not (Parent.Controls[i] is TCustomPanel) then Parent.Controls[i].Enabled := Value;
  end;
end;

function CheckPanelFilled(Panel:TCustomPanel):boolean;
var
   i:integer;
begin
  Result:=False;
  for i:=0 to Panel.ControlCount-1 do begin
    if (Panel.Controls[i] is TEdit) and (TEdit(Panel.Controls[i]).Text='') then begin exit; end;
    if (Panel.Controls[i] is TDateEdit) and (TDateEdit(Panel.Controls[i]).Text='  .  .    ') then begin exit; end;
    if (Panel.Controls[i] is TComboEdit) and (TComboEdit(Panel.Controls[i]).Text='') then begin exit; end;
    if (Panel.Controls[i] is TComboBox) and (TComboBox(Panel.Controls[i]).Text='') then begin exit; end;
  end;
  Result:=True;
end;

procedure ClearPanel(Panel:TWinControl);
var
  List : TList;
  i : integer;
begin
  List := TList.Create;
  Panel.GetTabOrderList(List);
  if List.Count>0 then begin
    for i:=0 to List.Count-1 do begin
      if TWinControl(List[i]).Enabled and TWinControl(List[i]).TabStop then begin
        if TWinControl(List[i]) is TCustomEdit then begin
          TCustomEdit(TWinControl(List[i])).Text := '';
        end else
        if TWinControl(List[i]) is TCustomDateEdit then begin
          TCustomDateEdit(TWinControl(List[i])).Date := Date;
          Application.ProcessMessages;
          TDateEdit(TWinControl(List[i])).Text := '  .  .    ';
        end else
        if TWinControl(List[i]) is TsCheckedControl then begin
          TsCheckedControl(TWinControl(List[i])).Checked := False;
        end else
        if TWinControl(List[i]) is TCheckBox then begin
          TCheckBox(TWinControl(List[i])).Checked := False;
        end else
        if TWinControl(List[i]) is TsCustomComboBox then begin
          TsCustomComboBox(TWinControl(List[i])).Active := True;
          TCustomComboBox(TWinControl(List[i])).ItemIndex := -1;
        end;
      end;
    end;
  end;
  List.Free;
end;

procedure Delay(MSecs: Integer);
var
  FirstTickCount : LongInt;
begin
  FirstTickCount:=GetTickCount;
  repeat
    Application.ProcessMessages; {allowing access to other controls, etc.}
  until ((GetTickCount-FirstTickCount) >= LongInt(MSecs));
end;

procedure ComboBoxFilling(ComboBox:TComboBox; DataSet:TDataSet; CodeField, NameField:string; CountSymb:integer; FromDOSToWIN: boolean);
begin
   with DataSet do begin
      DisableControls;
      open;
      first;
      while not eof do begin
        if CodeField<>'' then begin
         if FieldByName(CodeField).AsInteger < CountSymb then begin
          if FromDOSToWIN
            then ComboBox.Items.Add('0' + FieldByName(CodeField).AsString + ' - ' + OEMToAnsiStr(FieldByName(NameField).AsString))
            else ComboBox.Items.Add('0' + FieldByName(CodeField).AsString + ' - ' + FieldByName(NameField).AsString);
         end
         else begin
          if FromDOSToWIN
            then ComboBox.Items.Add(FieldByName(CodeField).AsString + ' - ' + OEMToAnsiStr(FieldByName(NameField).AsString))
            else ComboBox.Items.Add(FieldByName(CodeField).AsString + ' - ' + FieldByName(NameField).AsString);
         end;
        end
        else begin
          if FromDOSToWIN
            then ComboBox.Items.Add(OEMToAnsiStr(FieldByName(NameField).AsString))
            else ComboBox.Items.Add(FieldByName(NameField).AsString);
        end;
        next;
      end;
      EnableControls;
   end;
end;

end.
